• Discovering Gold LightOJ


    You are in a cave, a long cave! The cave can be represented by a 1 x N grid. Each cell of the cave can contain any amount of gold.

    Initially you are in position 1. Now each turn you throw a perfect 6 sided dice. If you get X in the dice after throwing, you add X to your position and collect all the gold from the new position. If your new position is outside the cave, then you keep throwing again until you get a suitable result. When you reach the Nth position you stop your journey. Now you are given the information about the cave, you have to find out the expected number of gold you can collect using the given procedure.

    Input

    Input starts with an integer T (≤ 100), denoting the number of test cases.

    Each case contains a blank line and an integer N (1 ≤ N ≤ 100) denoting the dimension of the cave. The next line contains N space separated integers. The ith integer of this line denotes the amount of gold you will get if you come to the ith cell. You may safely assume that all the given integers will be non-negative and no integer will be greater than 1000.

    Output

    For each case, print the case number and the expected number of gold you will collect. Errors less than 10-6 will be ignored.

    Sample Input

    3

    1

    101

    2

    10 3

    3

    3 6 9

    Sample Output

    Case 1: 101.0000000000

    Case 2: 13.000

    Case 3: 15

    题解:dp[ i ]=(dp[ i+1 ]+dp[ i+2 ]+dp[ i+3 ]+dp[ i+4 ]+dp[ i+5 ]+d[ i+6 ])/6+a[ i ].因为一定会到达终点n,所以试着倒推。

     1 #include<cstdio>
     2 #include<cstring>
     3 #include<iostream>
     4 #include<algorithm>
     5 using namespace std;
     6 
     7 int n,a[105];
     8 double dp[105];
     9 
    10 void solve(int t){
    11     for(int i=1;i<=n;i++) dp[i]=a[i];
    12     for(int i=n-1;i>=1;i--){
    13         int temp=min(6,n-i);
    14         for(int j=1;j<=temp;j++)
    15             dp[i]+=dp[i+j]/(double)temp; 
    16     }
    17     printf("Case %d: %.7lf
    ",t,dp[1]);
    18 }
    19 
    20 int main()
    21 {   int kase;
    22     cin>>kase;
    23     for(int t=1;t<=kase;t++){
    24         cin>>n;
    25         for(int i=1;i<=n;i++) cin>>a[i];
    26         solve(t);
    27     }
    28     return 0;
    29 }
  • 相关阅读:
    ZOJ 3631 Watashi's BG(dp+dfs)
    hdu 1506 Largest Rectangle in a Histogram(单调栈)
    csu 1392 Number Trick (数论)
    ACM 奋斗的小蜗牛
    ACM 16进制的简单运算
    ACM 交换输出
    ACM Longest Repeated Sequence
    ACM Arithmetic Expression
    ACM 素数
    ACM 无线网络覆盖
  • 原文地址:https://www.cnblogs.com/zgglj-com/p/7490784.html
Copyright © 2020-2023  润新知